=== modified file 'www/apps/browser/__init__.py'
--- www/apps/browser/__init__.py	2008-07-08 07:09:17 +0000
+++ www/apps/browser/__init__.py	2008-07-09 01:45:57 +0000
@@ -213,10 +213,10 @@
     """
     Presents a set of links/buttons for the "actions2" row of the top bar.
     This depends on whether it is a directory (listing) or normal file
-    (editor).
+    (editor), but we'll let the JavaScript decide which.
     """
-    if isdir:
-        req.write("""    <form target="upload_iframe"
+    req.write("""    <form id="actions2_directory"
+          target="upload_iframe"
           action="%s"
           enctype="multipart/form-data" method="post">
       Select:
@@ -240,8 +240,8 @@
           name="upload_iframe" id="upload_iframe"></iframe>
     </form>
 """ % cgi.escape(util.make_path(os.path.join("fileservice", req.path))))
-    else:
-        req.write("""    <p>Save as: 
+
+    req.write("""    <p id="actions2_file">Save as: 
       <input type="text" size="30" id="save_filename" value="%s" />
       <input type="button" id="save_button" value="Save" onclick="save_file()" />
     </p>

=== modified file 'www/media/browser/browser.css'
--- www/media/browser/browser.css	2008-04-11 07:26:08 +0000
+++ www/media/browser/browser.css	2008-07-09 01:45:57 +0000
@@ -87,6 +87,11 @@
     color: #aaa;
 }
 
+/* One of these two is shown at runtime, depending on the context. */
+#actions2 #actions2_file, #actions2 #actions2_directory {
+    display: none;
+}
+
 /* Everything under the top bar */
 
 #filesbody {

=== modified file 'www/media/browser/browser.js'
--- www/media/browser/browser.js	2008-07-08 07:09:17 +0000
+++ www/media/browser/browser.js	2008-07-09 01:45:57 +0000
@@ -799,9 +799,18 @@
      * when the current file is not a directory. Hence, just remove
      * it entirely.
      * (This makes some of the above decisions somewhat redundant).
+     * We also take this opportunity to show the appropriate actions2
+     * bar for this path. It should either be a save or upload widget.
      */
-    if (!(current_file.isdir))
-    {
+    if (current_file.isdir)
+    {
+        var actions2_directory = document.getElementById("actions2_directory");
+        actions2_directory.setAttribute("style", "display: inline;");
+    }
+    else
+    {
+        var actions2_file = document.getElementById("actions2_file");
+        actions2_file.setAttribute("style", "display: inline;");
         var moreactions = document.getElementById("moreactions_area");
         moreactions.setAttribute("style", "display: none;");
     }

